// ExpRun.h   generic Experiment Run control object
//
// this must be used to fill in a more
// specific object for a particular model.
// I don't know how to use advanced objC feature to do
// this right.

#import <swarmobject.h>
#import <collections.h>

#import "RParameter.h"

@interface ExpRun: SwarmObject {
	unsigned    	T;	 // simulation clock time
	unsigned		stopT;
	id				Parameters;
    FILE        	*reportFILE;
	char			startDate[32], startTime[32];
	char			*Version, *ProgName;
}

-createEnd: (id) aZone;
-setRDebug: (id) par;

-processCmdLineParameters: (id) aZone 
	  ArgC: (int) argc ArgV: (char **) argv;

-startRNG;

-(int) readParFile;

-getParFor: (char *) name;
-(char *) getParStringValueFor: (char *) name;
-(double) getDParValueFor: (char *) name;
-(unsigned int) getUParValueFor: (char *) name;
-(int) getIParValueFor: (char *) name;
-(char *) getStrParValueFor: (char *) name;
-(char) getCParValueFor: (char *) name;
-(BOOL) getBParValueFor: (char *) name;

-(int) setExpRunPar: (char *) name To: (char *) value;
-(int) setpar: (char *) parnv;

-(unsigned) getT;
-(unsigned) getstopT;
-setstopT: (unsigned) t;

-(char *) setstartDateTime;
-(char *) getTime;
-(char *) getSeconds;

-(char *) getVersion;
-(char *) getProgName;
-(id) getParameters;

-(FILE *) getreportFILE;

-(FILE *) openOutputFile: (char *) name How: (char *) how;
-startExpRunReportFile;

-help;
-displayParameters;

@end





